

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>igraphx_simulations.simulations &mdash; NetExt1 1 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script src="../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> NetExt1
          

          
          </a>

          
            
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../igraphx.html">Network network_extensions.igraphx</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../multilayer.html">Network network_extensions.multilayer</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../simulations.html">Network igraphx_simulations.simulations</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../semantic.html">Network network_extensions.semantic</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../structure_simulations.html">Result structure of a simulation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../graph_plotly.html">Helpers for plotly</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">NetExt1</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../index.html">Module code</a> &raquo;</li>
        
      <li>igraphx_simulations.simulations</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for igraphx_simulations.simulations</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">collections</span> <span class="k">import</span> <span class="n">defaultdict</span>
<span class="kn">import</span> <span class="nn">igraph</span>
<span class="kn">import</span> <span class="nn">pandas</span>
<span class="kn">from</span> <span class="nn">itertools</span> <span class="k">import</span> <span class="n">product</span>
<span class="kn">import</span> <span class="nn">math</span>
<span class="kn">import</span> <span class="nn">logging</span>


<span class="c1">#TYPES = [&quot;graphs&quot;,&quot;largest_component&quot;,&quot;undirected&quot;,&quot;largest_component_undirected&quot;,&quot;simplified&quot;,&quot;simplified_undirected&quot;]</span>

<span class="n">logger</span> <span class="o">=</span> <span class="n">logging</span><span class="o">.</span><span class="n">getLogger</span><span class="p">(</span><span class="vm">__name__</span><span class="p">)</span>

<span class="n">STANDARD_PROPS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;no_nodes&quot;</span><span class="p">,</span><span class="s2">&quot;no_edges&quot;</span><span class="p">,</span>
                  <span class="s2">&quot;no_nodes_div_edges&quot;</span><span class="p">,</span>
                  <span class="s2">&quot;density&quot;</span><span class="p">,</span><span class="s2">&quot;average_path_length&quot;</span><span class="p">,</span>
                  <span class="s2">&quot;transitivity_undirected&quot;</span><span class="p">,</span><span class="s2">&quot;radius&quot;</span><span class="p">]</span>
<span class="n">SIM_METHODS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Erdos_Renyi&quot;</span><span class="p">,</span><span class="s2">&quot;Barabasi&quot;</span><span class="p">]</span>

<span class="k">def</span> <span class="nf">calculate_mean_values</span><span class="p">(</span><span class="n">simulations</span><span class="p">,</span><span class="n">typs</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;graphs&quot;</span><span class="p">,</span><span class="s2">&quot;largest_component&quot;</span><span class="p">]):</span>
    <span class="k">for</span> <span class="n">typ</span> <span class="ow">in</span> <span class="n">typs</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">sim</span><span class="p">,</span><span class="n">properties</span> <span class="ow">in</span> <span class="n">simulations</span><span class="p">[</span><span class="s2">&quot;properties&quot;</span><span class="p">][</span><span class="n">typ</span><span class="p">]</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">properties</span><span class="p">:</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">properties</span><span class="p">[</span><span class="s2">&quot;mean_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="n">numpy</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">properties</span><span class="p">[</span><span class="n">p</span><span class="p">]]</span>
                    <span class="n">properties</span><span class="p">[</span><span class="s2">&quot;std_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="n">numpy</span><span class="o">.</span><span class="n">std</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">properties</span><span class="p">[</span><span class="n">p</span><span class="p">]]</span>
                <span class="k">except</span> <span class="ne">KeyError</span><span class="p">:</span>
                    <span class="nb">print</span><span class="p">(</span><span class="n">properties</span><span class="p">)</span>
                    <span class="k">raise</span> <span class="ne">KeyError</span>


<div class="viewcode-block" id="calculate_diffs"><a class="viewcode-back" href="../../simulations.html#igraphx_simulations.simulations.calculate_diffs">[docs]</a><span class="k">def</span> <span class="nf">calculate_diffs</span><span class="p">(</span><span class="n">simulations</span><span class="p">,</span><span class="n">graphproperties</span><span class="p">,</span><span class="n">typs</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;graphs&quot;</span><span class="p">,</span><span class="s2">&quot;largest_component&quot;</span><span class="p">]):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Calculate the difference (difference and quotient of real value and simulations.</span>
<span class="sd">    Returns the means difference over the whole time period.</span>
<span class="sd">    The differences are added to the graph properties</span>
<span class="sd">    :param simulations: Results of simulations</span>
<span class="sd">    :param graphproperties: Values of the year graphs for some properties, differences and quotient will be added here!</span>
<span class="sd">    :param typs: (optional) defaults to &quot;graphs&quot; and &quot;largest component&quot;</span>
<span class="sd">    :param props: (options) props to be calculates defaults to [&quot;no_nodes&quot;,&quot;no_edges&quot;,&quot;no_nodes_div_edges&quot;]</span>
<span class="sd">    :return:</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">retV</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">typ</span> <span class="ow">in</span> <span class="n">typs</span><span class="p">:</span>
        <span class="n">rets</span> <span class="o">=</span><span class="n">defaultdict</span><span class="p">(</span><span class="nb">dict</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">sim</span><span class="p">,</span><span class="n">properties</span> <span class="ow">in</span> <span class="n">simulations</span><span class="p">[</span><span class="s2">&quot;properties&quot;</span><span class="p">][</span><span class="n">typ</span><span class="p">]</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">properties</span><span class="p">:</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">properties</span><span class="p">[</span><span class="s2">&quot;div_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">]</span> <span class="o">=</span> <span class="n">graphproperties</span><span class="p">[</span><span class="n">typ</span><span class="p">][</span><span class="n">p</span><span class="p">]</span><span class="o">/</span><span class="n">properties</span><span class="p">[</span><span class="s2">&quot;mean_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">]</span>
                    <span class="n">properties</span><span class="p">[</span><span class="s2">&quot;diff_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">]</span> <span class="o">=</span> <span class="p">(</span><span class="n">graphproperties</span><span class="p">[</span><span class="n">typ</span><span class="p">][</span><span class="n">p</span><span class="p">]</span><span class="o">-</span><span class="n">properties</span><span class="p">[</span><span class="s2">&quot;mean_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">])</span><span class="o">/</span><span class="n">properties</span><span class="p">[</span><span class="s2">&quot;mean_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">]</span>
               
                    <span class="n">rets</span><span class="p">[</span><span class="n">sim</span><span class="p">][</span><span class="n">p</span><span class="p">]</span> <span class="o">=</span> <span class="n">math</span><span class="o">.</span><span class="n">sqrt</span><span class="p">((</span><span class="n">properties</span><span class="p">[</span><span class="s2">&quot;diff_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">]</span><span class="o">**</span><span class="mi">2</span><span class="p">)</span><span class="o">.</span><span class="n">sum</span><span class="p">())</span><span class="o">/</span><span class="nb">len</span><span class="p">(</span><span class="n">properties</span><span class="p">[</span><span class="s2">&quot;mean_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">])</span>
                    <span class="n">rets</span><span class="p">[</span><span class="n">sim</span><span class="p">][</span><span class="n">p</span><span class="o">+</span><span class="s2">&quot;_mean&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">graphproperties</span><span class="p">[</span><span class="n">typ</span><span class="p">][</span><span class="n">p</span><span class="p">]</span><span class="o">.</span><span class="n">mean</span><span class="p">()</span>
                    <span class="n">rets</span><span class="p">[</span><span class="n">sim</span><span class="p">][</span><span class="n">p</span><span class="o">+</span><span class="s2">&quot;_mean_sim&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">properties</span><span class="p">[</span><span class="s2">&quot;mean_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">p</span><span class="p">]</span><span class="o">.</span><span class="n">mean</span><span class="p">()</span>
                <span class="k">except</span> <span class="ne">KeyError</span><span class="p">:</span>
                    <span class="k">pass</span> <span class="c1"># should be ignored, can happen if p is a calculated mean_</span>
                
        <span class="n">retV</span><span class="p">[</span><span class="n">typ</span><span class="p">]</span><span class="o">=</span><span class="n">rets</span>      
    <span class="k">return</span> <span class="n">retV</span></div>
            
            


<span class="k">def</span> <span class="nf">calculate_edge_node_functions</span><span class="p">(</span><span class="n">simulations</span><span class="p">,</span><span class="n">graphproperties</span> <span class="o">=</span> <span class="kc">None</span><span class="p">):</span>
    <span class="k">for</span> <span class="n">graphs_set</span> <span class="ow">in</span> <span class="p">[</span><span class="s2">&quot;graphs&quot;</span><span class="p">,</span><span class="s2">&quot;largest_component&quot;</span><span class="p">]:</span>
        <span class="k">for</span> <span class="n">sim_name</span><span class="p">,</span><span class="n">simulation</span> <span class="ow">in</span> <span class="n">simulations</span><span class="p">[</span><span class="n">graphs_set</span><span class="p">]</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>  
            <span class="n">graphproperties</span> <span class="o">=</span> <span class="n">simulations</span><span class="p">[</span><span class="s2">&quot;properties&quot;</span><span class="p">][</span><span class="n">graphs_set</span><span class="p">][</span><span class="n">sim_name</span><span class="p">]</span> <span class="c1"># dataframe mit allen properties für dieses Simulations  (columns = index = years)</span>
           
            <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_nodes&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">pandas</span><span class="o">.</span><span class="n">Series</span><span class="p">(</span><span class="n">index</span><span class="o">=</span><span class="n">graphproperties</span><span class="o">.</span><span class="n">index</span><span class="p">,</span><span class="n">dtype</span><span class="o">=</span><span class="nb">object</span><span class="p">)</span>
            <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_edges&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">pandas</span><span class="o">.</span><span class="n">Series</span><span class="p">(</span><span class="n">index</span><span class="o">=</span><span class="n">graphproperties</span><span class="o">.</span><span class="n">index</span><span class="p">,</span><span class="n">dtype</span><span class="o">=</span><span class="nb">object</span><span class="p">)</span>
            <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_nodes_div_edges&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">pandas</span><span class="o">.</span><span class="n">Series</span><span class="p">(</span><span class="n">index</span><span class="o">=</span><span class="n">graphproperties</span><span class="o">.</span><span class="n">index</span><span class="p">,</span><span class="n">dtype</span><span class="o">=</span><span class="nb">object</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">y</span><span class="p">,</span><span class="n">gr_its</span> <span class="ow">in</span> <span class="n">simulations</span><span class="p">[</span><span class="n">graphs_set</span><span class="p">][</span><span class="n">sim_name</span><span class="p">]</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>          
               
                <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_nodes&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">y</span><span class="p">]</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">empty</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">gr_its</span><span class="p">))</span><span class="c1">#pandas.Series(index=list(range(0,len(gr_its))))</span>
                <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_edges&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">y</span><span class="p">]</span> <span class="o">=</span>  <span class="n">numpy</span><span class="o">.</span><span class="n">empty</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">gr_its</span><span class="p">))</span><span class="c1">#pandas.Series(index=range(0,len(gr_its)))</span>

                <span class="k">for</span> <span class="n">gr_index</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">gr_its</span><span class="p">)):</span> <span class="c1">#durch alle iterationen</span>
                    <span class="n">gr</span> <span class="o">=</span> <span class="n">gr_its</span><span class="p">[</span><span class="n">gr_index</span><span class="p">]</span>
                    
                    <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_nodes&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">y</span><span class="p">][</span><span class="n">gr_index</span><span class="p">]</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">gr</span><span class="o">.</span><span class="n">vs</span><span class="p">)</span>
                    <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_edges&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">y</span><span class="p">][</span><span class="n">gr_index</span><span class="p">]</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">gr</span><span class="o">.</span><span class="n">es</span><span class="p">)</span>
                 
                <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_nodes_div_edges&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">y</span><span class="p">]</span><span class="o">=</span> <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_nodes&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">y</span><span class="p">]</span><span class="o">/</span> <span class="n">graphproperties</span><span class="p">[</span><span class="s2">&quot;no_edges&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">y</span><span class="p">]</span>
    
<div class="viewcode-block" id="simulate_largest_components"><a class="viewcode-back" href="../../simulations.html#igraphx_simulations.simulations.simulate_largest_components">[docs]</a><span class="k">def</span> <span class="nf">simulate_largest_components</span><span class="p">(</span><span class="n">ynw</span><span class="p">,</span><span class="n">typ</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">iterations</span><span class="o">=</span><span class="mi">10</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;this method takes a year-network and creates - simular graphs with Erdos_Renyi and Barabasi</span>
<span class="sd">    and returns yeargraphs for both cases and the development of some graph properties</span>
<span class="sd">    (no of nodes and no of edges)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">simulations</span><span class="o">=</span><span class="n">defaultdict</span><span class="p">(</span><span class="nb">dict</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">it</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">iterations</span><span class="p">):</span>
        <span class="n">arb_er</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="n">lc_er</span> <span class="o">=</span> <span class="p">{}</span>

        <span class="k">for</span> <span class="n">y</span><span class="p">,</span><span class="n">graph</span> <span class="ow">in</span> <span class="n">ynw</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>    
                <span class="n">arb_er</span><span class="p">[</span><span class="n">y</span><span class="p">]</span> <span class="o">=</span> <span class="n">igraph</span><span class="o">.</span><span class="n">Graph</span><span class="o">.</span><span class="n">Erdos_Renyi</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">graph</span><span class="o">.</span><span class="n">vs</span><span class="p">),</span><span class="n">m</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">graph</span><span class="o">.</span><span class="n">es</span><span class="p">))</span>
                <span class="n">lc_er</span><span class="p">[</span><span class="n">y</span><span class="p">]</span> <span class="o">=</span> <span class="n">arb_er</span><span class="p">[</span><span class="n">y</span><span class="p">]</span><span class="o">.</span><span class="n">components</span><span class="p">(</span><span class="n">mode</span><span class="o">=</span><span class="n">igraph</span><span class="o">.</span><span class="n">WEAK</span><span class="p">)</span><span class="o">.</span><span class="n">giant</span><span class="p">()</span>
            
        <span class="n">simulations</span><span class="p">[</span><span class="s2">&quot;Erdos_Renyi&quot;</span><span class="p">][</span><span class="n">it</span><span class="p">]</span><span class="o">=</span><span class="p">{</span><span class="s2">&quot;graph&quot;</span><span class="p">:</span><span class="n">arb_er</span><span class="o">.</span><span class="n">copy</span><span class="p">(),</span>
                                         <span class="s2">&quot;largest_component&quot;</span><span class="p">:</span><span class="n">lc_er</span><span class="o">.</span><span class="n">copy</span><span class="p">()</span>
                                         <span class="c1">#&quot;graphproperties&quot;:pandas.DataFrame()</span>
                                         <span class="p">}</span>

        <span class="n">arb</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="n">lc</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">y</span><span class="p">,</span> <span class="n">graph</span> <span class="ow">in</span> <span class="n">ynw</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">graph</span><span class="o">.</span><span class="n">is_directed</span><span class="p">():</span>
                <span class="n">arb</span><span class="p">[</span><span class="n">y</span><span class="p">]</span> <span class="o">=</span> <span class="n">igraph</span><span class="o">.</span><span class="n">Graph</span><span class="o">.</span><span class="n">Barabasi</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">graph</span><span class="o">.</span><span class="n">vs</span><span class="p">),</span> <span class="n">graph</span><span class="o">.</span><span class="n">vs</span><span class="o">.</span><span class="n">degree</span><span class="p">(</span><span class="n">mode</span> <span class="o">=</span> <span class="n">igraph</span><span class="o">.</span><span class="n">OUT</span><span class="p">),</span><span class="n">directed</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">arb</span><span class="p">[</span><span class="n">y</span><span class="p">]</span> <span class="o">=</span> <span class="n">igraph</span><span class="o">.</span><span class="n">Graph</span><span class="o">.</span><span class="n">Barabasi</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">graph</span><span class="o">.</span><span class="n">vs</span><span class="p">),</span> <span class="n">graph</span><span class="o">.</span><span class="n">vs</span><span class="o">.</span><span class="n">degree</span><span class="p">())</span>

            <span class="n">lc</span><span class="p">[</span><span class="n">y</span><span class="p">]</span> <span class="o">=</span> <span class="n">arb</span><span class="p">[</span><span class="n">y</span><span class="p">]</span><span class="o">.</span><span class="n">components</span><span class="p">(</span><span class="n">mode</span><span class="o">=</span><span class="n">igraph</span><span class="o">.</span><span class="n">WEAK</span><span class="p">)</span><span class="o">.</span><span class="n">giant</span><span class="p">()</span>

        <span class="n">simulations</span><span class="p">[</span><span class="s2">&quot;Barabasi&quot;</span><span class="p">][</span><span class="n">it</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;graph&quot;</span><span class="p">:</span> <span class="n">arb</span><span class="o">.</span><span class="n">copy</span><span class="p">(),</span>
                                       <span class="s2">&quot;largest_component&quot;</span><span class="p">:</span> <span class="n">lc</span><span class="o">.</span><span class="n">copy</span><span class="p">()</span>
                                       <span class="c1">#&quot;graphproperties&quot;: pandas.DataFrame()</span>
                                       <span class="p">}</span>
    <span class="k">return</span> <span class="n">simulations</span></div>



<span class="k">def</span> <span class="nf">addProperty</span><span class="p">(</span><span class="n">graphproperties_all</span><span class="p">,</span><span class="n">func</span><span class="p">,</span><span class="n">graphs</span><span class="p">,</span><span class="n">params</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">kwargs</span><span class="o">=</span><span class="p">{},</span>
                <span class="n">simulations</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
                <span class="n">reset</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>

    <span class="c1">##simulations = simulations[graph_type][&quot;Barbasi&quot;][it][graph|largest_component|graphproperties][y]</span>
    <span class="k">if</span> <span class="n">simulations</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="s2">&quot;simulations must not be none!&quot;</span><span class="p">)</span>
        <span class="k">raise</span> <span class="ne">ValueError</span>

    <span class="n">simulations_in</span> <span class="o">=</span> <span class="n">simulations</span>

    <span class="c1"># first the values for the original graphs</span>
    <span class="k">for</span> <span class="n">graph_type</span><span class="p">,</span><span class="n">graph_y</span> <span class="ow">in</span> <span class="n">graphs</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
        <span class="k">for</span> <span class="n">y</span><span class="p">,</span><span class="n">graph</span> <span class="ow">in</span> <span class="n">graph_y</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">for</span> <span class="n">gr_tp</span> <span class="ow">in</span> <span class="p">[</span><span class="s2">&quot;graph&quot;</span><span class="p">,</span><span class="s2">&quot;largest_component&quot;</span><span class="p">]:</span>
                <span class="k">if</span> <span class="n">gr_tp</span> <span class="o">==</span> <span class="s2">&quot;largest_component&quot;</span><span class="p">:</span>
                    <span class="n">gr_tmp</span> <span class="o">=</span> <span class="n">graph</span><span class="o">.</span><span class="n">components</span><span class="p">(</span><span class="n">mode</span><span class="o">=</span><span class="n">igraph</span><span class="o">.</span><span class="n">WEAK</span><span class="p">)</span><span class="o">.</span><span class="n">giant</span><span class="p">()</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">gr_tmp</span> <span class="o">=</span> <span class="n">graph</span>

                <span class="k">if</span> <span class="n">func</span> <span class="o">==</span> <span class="s2">&quot;no_nodes&quot;</span><span class="p">:</span>
                    <span class="n">val</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">gr_tmp</span><span class="o">.</span><span class="n">vs</span><span class="p">)</span>
                <span class="k">elif</span> <span class="n">func</span> <span class="o">==</span> <span class="s2">&quot;no_edges&quot;</span><span class="p">:</span>
                    <span class="n">val</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">gr_tmp</span><span class="o">.</span><span class="n">es</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">val</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">gr_tmp</span><span class="p">,</span> <span class="n">func</span><span class="p">)(</span><span class="n">params</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

                <span class="n">addToDataFrame</span><span class="p">(</span><span class="n">graphproperties_all</span><span class="p">[</span><span class="n">graph_type</span><span class="p">][</span><span class="s2">&quot;original&quot;</span><span class="p">],</span><span class="s2">&quot;</span><span class="si">%s</span><span class="s2">_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="p">(</span><span class="n">gr_tp</span><span class="p">,</span><span class="n">func</span><span class="p">),</span><span class="n">y</span><span class="p">,</span><span class="n">val</span><span class="p">)</span>

    <span class="c1">#now the simulations</span>
    <span class="k">for</span> <span class="n">graph_type</span><span class="p">,</span><span class="n">simulation</span> <span class="ow">in</span> <span class="n">simulations_in</span><span class="o">.</span><span class="n">items</span><span class="p">():</span> <span class="c1"># is</span>
        <span class="c1">#grp_it = pandas.DataFrame(columns=SIM_METHODS,index = range(1900,200))</span>
        <span class="n">graphproperties_subgraph</span> <span class="o">=</span> <span class="n">graphproperties_all</span><span class="p">[</span><span class="n">graph_type</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">func</span> <span class="ow">in</span> <span class="n">graphproperties_subgraph</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">reset</span><span class="p">:</span>
            <span class="k">continue</span>

        <span class="c1">#graphproperties = graphproperties.transpose()</span>
        <span class="c1">#graphproperties[func] = pandas.Series(index=graphproperties.index)</span>
        <span class="k">for</span> <span class="n">sim_type</span><span class="p">,</span><span class="n">graphs_it</span> <span class="ow">in</span> <span class="n">simulation</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">grp_it</span> <span class="o">=</span> <span class="n">defaultdict</span><span class="p">(</span><span class="k">lambda</span><span class="p">:</span> <span class="n">defaultdict</span><span class="p">(</span><span class="nb">list</span><span class="p">))</span>
            <span class="c1"># initialize grp_it</span>
            <span class="c1">#for gt in graphs_it[0].keys():</span>
             <span class="c1">#   for y in range(1900, 2000):  # todo get years from somewhere</span>
             <span class="c1">#       grp_it[gt][y] = []</span>

            <span class="k">for</span> <span class="n">it</span><span class="p">,</span><span class="n">graph_type_graph</span> <span class="ow">in</span> <span class="n">graphs_it</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>

                <span class="k">for</span> <span class="n">graph_type_simulation</span><span class="p">,</span><span class="n">gra</span> <span class="ow">in</span> <span class="n">graph_type_graph</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                    <span class="k">for</span> <span class="n">y</span><span class="p">,</span><span class="n">graph</span> <span class="ow">in</span> <span class="n">gra</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                            <span class="k">if</span> <span class="n">func</span> <span class="o">==</span> <span class="s2">&quot;no_nodes&quot;</span><span class="p">:</span>
                                    <span class="n">val</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">graph</span><span class="o">.</span><span class="n">vs</span><span class="p">)</span>
                            <span class="k">elif</span> <span class="n">func</span> <span class="o">==</span> <span class="s2">&quot;no_edges&quot;</span><span class="p">:</span>
                                <span class="n">val</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">graph</span><span class="o">.</span><span class="n">es</span><span class="p">)</span>
                            <span class="k">else</span><span class="p">:</span>
                                <span class="n">val</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">graph</span><span class="p">,</span><span class="n">func</span><span class="p">)(</span><span class="n">params</span><span class="p">,</span><span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
                            <span class="c1">#addToDataFrame(graphproperties_subgraph,&quot;%s_%s_%s&quot;%(sim_sub_graph_type,graph_type,func),y,val)</span>
                            <span class="n">grp_it</span><span class="p">[</span><span class="n">graph_type_simulation</span><span class="p">][</span><span class="n">y</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
                            <span class="c1">#print(grp_it)</span>
            <span class="c1">#now we add the mean of simulations to the properties</span>
            <span class="k">for</span> <span class="n">gt_simulation</span><span class="p">,</span><span class="n">val_y</span> <span class="ow">in</span> <span class="n">grp_it</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="k">for</span> <span class="n">y</span><span class="p">,</span><span class="n">val</span> <span class="ow">in</span> <span class="n">val_y</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                    <span class="n">val</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
                    <span class="n">addToDataFrame</span><span class="p">(</span><span class="n">graphproperties_subgraph</span><span class="p">[</span><span class="n">sim_type</span><span class="p">],</span><span class="s2">&quot;</span><span class="si">%s</span><span class="s2">_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="p">(</span><span class="n">gt_simulation</span><span class="p">,</span><span class="n">func</span><span class="p">),</span><span class="n">y</span><span class="p">,</span><span class="n">val</span><span class="p">)</span>

    <span class="k">return</span>
                    
<span class="k">def</span> <span class="nf">addToDataFrame</span><span class="p">(</span><span class="n">df</span><span class="p">,</span><span class="n">c</span><span class="p">,</span><span class="n">i</span><span class="p">,</span><span class="n">v</span><span class="p">):</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">c</span> <span class="ow">in</span> <span class="n">df</span><span class="p">:</span>
        <span class="n">df</span><span class="p">[</span><span class="n">c</span><span class="p">]</span> <span class="o">=</span> <span class="n">pandas</span><span class="o">.</span><span class="n">Series</span><span class="p">()</span>
    <span class="n">df</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">i</span><span class="p">,</span><span class="n">c</span><span class="p">]</span> <span class="o">=</span> <span class="n">v</span>


<span class="kn">import</span> <span class="nn">numpy</span>
<span class="k">def</span> <span class="nf">addPropertyMean</span><span class="p">(</span><span class="n">simulations</span><span class="p">,</span><span class="n">func</span><span class="p">,</span><span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">typs</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;graphs&quot;</span><span class="p">,</span><span class="s2">&quot;largest_component&quot;</span><span class="p">],</span><span class="n">reset</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span><span class="n">params</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">kwargs</span><span class="o">=</span><span class="p">{}):</span> 
        <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">name</span> <span class="o">=</span> <span class="n">func</span><span class="o">+</span><span class="s2">&quot;_</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">name</span>
        <span class="k">else</span><span class="p">:</span>
                <span class="n">name</span> <span class="o">=</span> <span class="n">func</span>
        <span class="k">for</span> <span class="n">typ</span> <span class="ow">in</span> <span class="n">typs</span><span class="p">:</span>
     
            <span class="k">for</span> <span class="n">t</span><span class="p">,</span><span class="n">sim</span> <span class="ow">in</span> <span class="n">simulations</span><span class="p">[</span><span class="n">typ</span><span class="p">]</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="k">if</span> <span class="s2">&quot;</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">name</span> <span class="ow">in</span> <span class="n">simulations</span><span class="p">[</span><span class="s2">&quot;properties&quot;</span><span class="p">][</span><span class="n">typ</span><span class="p">][</span><span class="n">t</span><span class="p">]</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">reset</span><span class="p">:</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;cached&quot;</span><span class="p">)</span>
                    <span class="k">continue</span>
                    
                
                <span class="c1">#simulations[&quot;properties&quot;][typ][t][&quot;%s&quot;%name] = pandas.Series(index=simulations[&quot;properties&quot;][typ][t].index,dtype=object)</span>
                <span class="n">simulations</span><span class="p">[</span><span class="s2">&quot;properties&quot;</span><span class="p">][</span><span class="n">typ</span><span class="p">][</span><span class="n">t</span><span class="p">][</span><span class="s2">&quot;</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="n">pandas</span><span class="o">.</span><span class="n">Series</span><span class="p">(</span><span class="n">index</span><span class="o">=</span><span class="n">simulations</span><span class="p">[</span><span class="s2">&quot;properties&quot;</span><span class="p">][</span><span class="n">typ</span><span class="p">][</span><span class="n">t</span><span class="p">]</span><span class="o">.</span><span class="n">index</span><span class="p">,</span><span class="n">dtype</span><span class="o">=</span><span class="nb">object</span><span class="p">)</span>
                <span class="k">for</span> <span class="n">y</span><span class="p">,</span><span class="n">grs</span> <span class="ow">in</span> <span class="n">sim</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                    <span class="c1">#graphsIteration = </span>
                    <span class="n">val</span> <span class="o">=</span> <span class="p">[]</span>
                    <span class="k">for</span> <span class="n">gr</span> <span class="ow">in</span> <span class="n">grs</span><span class="p">:</span>
                        <span class="n">val</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="nb">getattr</span><span class="p">(</span><span class="n">gr</span><span class="p">,</span><span class="n">func</span><span class="p">)(</span><span class="n">params</span><span class="p">,</span><span class="o">**</span><span class="n">kwargs</span><span class="p">))</span>         
    
                    <span class="n">simulations</span><span class="p">[</span><span class="s2">&quot;properties&quot;</span><span class="p">][</span><span class="n">typ</span><span class="p">][</span><span class="n">t</span><span class="p">][</span><span class="s2">&quot;</span><span class="si">%s</span><span class="s2">&quot;</span><span class="o">%</span><span class="n">name</span><span class="p">][</span><span class="n">y</span><span class="p">]</span><span class="o">=</span><span class="n">numpy</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
                   
     
</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Dirk Wintergrün

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>